Index: main/dsp.c
===================================================================
--- main/dsp.c	(revision 258772)
+++ main/dsp.c	(working copy)
@@ -385,6 +385,7 @@
 	int digitmode;
 	int faxmode;
 	int dtmf_began;
+	struct timeval dtmf_tv;
 	int display_inband_dtmf_warning;
 	float genergy;
 	int mute_fragments;
@@ -1385,6 +1386,7 @@
 		if (dsp->digit_state.current_digits) {
 			int event = 0;
 			char event_digit = 0;
+			long event_len = 0;
 
 			if (!dsp->dtmf_began) {
 				/* We have not reported DTMF_BEGIN for anything yet */
@@ -1392,6 +1394,7 @@
 				if (dsp->features & DSP_FEATURE_DIGIT_DETECT) {
 					event = AST_FRAME_DTMF_BEGIN;
 					event_digit = dsp->digit_state.digits[0];
+					dsp->dtmf_tv = ast_tvnow();
 				}
 				dsp->dtmf_began = 1;
 
@@ -1400,6 +1403,7 @@
 				if (dsp->features & DSP_FEATURE_DIGIT_DETECT) {
 					event = AST_FRAME_DTMF_END;
 					event_digit = dsp->digit_state.digits[0];
+					event_len = ast_tvdiff_ms(ast_tvnow(), dsp->dtmf_tv);
 				}
 				memmove(dsp->digit_state.digits, dsp->digit_state.digits + 1, dsp->digit_state.current_digits);
 				dsp->digit_state.current_digits--;
@@ -1417,6 +1421,7 @@
 				memset(&dsp->f, 0, sizeof(dsp->f));
 				dsp->f.frametype = event;
 				dsp->f.subclass.integer = event_digit;
+				dsp->f.len = event_len;
 				outf = &dsp->f;
 				goto done;
 			}
